function configuration_reporting (instance, widget) {
    "use strict";
    var widgets = widget;

    widget.ReportingUtilityGoldenWidget = instance.Widget.extend({
        template: 'ReportingUtilityGolden',
        events: {
            'click .report_action > button': 'clickOnReport',
        },
        reports: [

            {
                title: 'Listado de utilidad de productos por ventas',
                description: 'Permite visualizar un listado de utilidad de productos por ventas.',
                action: 'ReportInvoiceUtility'
            }

        ],
        start: function () {
            var self = this;
            self.fetchInitial();
        },

        clickOnReport: function (e) {
            var templateName = this.$el.find(e.target).val();
            this.renderReport(templateName);
        },

        renderReport: function (templateName) {
            var Widget = this.getWidgetFromTemplate(templateName);
            var WidgetInstance = new Widget(this);
            var container = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
            container.find('.report_view').hide({
                effect: 'fade',
                duration: 200,
                complete: function () {
                    WidgetInstance.appendTo(container);
                }
            });
        },

        getWidgetFromTemplate: function (templateName) {
            var widgetName = `${templateName}Widget`;
            return _.pick(widget, widgetName)[widgetName];
        },

        fetchInitial:function() {
            var self = this;
            self.fetchCurrentUser().then(function (CurrentUser) {
                return CurrentUser;
            }).then(function (CurrentUser) {
                self.CurrentUser = CurrentUser;
                return self.fetchResUser(CurrentUser);
            }).then(function (ResUser) {
                self.ResUser = ResUser;
                return self.InsertUser();
            });
        },

        fetchCurrentUser: function() {
            var self = this;
            var ResUser = new instance.web.Model('res.users');
            return ResUser.call('get_user', {
                context: new instance.web.CompoundContext()
            });
        },

        fetchResUser: function(id) {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name'];
            var domain = [['id','=',id]];
            var ResUser = new instance.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        InsertUser: function(id) {
            var self = this;
            var user = self.ResUser[0].name;
            self.$el.find('.user-content').find('p').text("Hola " + user + " ...!");
        },

    });
}
